


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("widget");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("widget");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;												// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var lpi=0;var rN;var rr=20;var rw=new Array();var nrw=new Array();var dl=0;var exc=new Array();var va=0;var sr="";var nw;var bu="http://spy.macrumors.com/";var su;var ig;var bd;
function i(){h();g();ex()}
function x(){if(window.XMLHttpRequest){rN=new XMLHttpRequest()}else if(window.ActiveXObject){try{rN=new ActiveXObject("Msxml2.XMLHTTP")}catch(e){try{rN=new ActiveXObject("Microsoft.XMLHTTP")}catch(e){}}}}
function s(){x();var nid=(Math.round(Math.random()*2000)+100);if(rN){if(sr=='p'){url=bu+'?do=xml&lpi='+lpi+"&"}else{url=bu+'spy.xml?'}rN.onreadystatechange=p;rN.open("GET",url+nid,true);rN.send(null)}setTimeout("s()",rr*1000)}
function p(){if(rN.readyState==4){if(rN.status==200){var ps=rN.responseXML.getElementsByTagName("post");if(ps.length>0){pr(ps);lpi=parseInt(ps[0].getElementsByTagName("postid")[0].firstChild.nodeValue);dl=(rr/nrw.length)*1000;d()}}}}
function p2(){if(rN.readyState==4){if(rN.status==200){var ps=rN.responseXML.getElementsByTagName("post");var rv=new Array();if(ps.length>0){for(i=ps.length-1;i>=5;i--){rv.push(ps[i])}pr(rv);lpi=parseInt(ps[5].getElementsByTagName("postid")[0].firstChild.nodeValue);rw=nrw;g();s()}}}}
function pr(ps){nrw=new Array();for(i=0;i<ps.length;i++){if(parseInt(ps[i].getElementsByTagName("postid")[0].firstChild.nodeValue)>lpi){var isu=0;var igd=0;var ibd=0;for(j=0;j<su.length;j++){if(su[j]==ps[i].getElementsByTagName("id")[0].firstChild.nodeValue){isu=1}}for(j=0;j<ig.length;j++){if(ig[j]==ps[i].getElementsByTagName("userid")[0].firstChild.nodeValue){igd=1}}for(j=0;j<bd.length;j++){if(bd[j]==ps[i].getElementsByTagName("userid")[0].firstChild.nodeValue){ibd=1}}if(!igd){rc=ps[i].getElementsByTagName("replycount")[0].firstChild.nodeValue;var inf=new Array(ps[i].getElementsByTagName("forumid")[0].firstChild.nodeValue,"<tr>"+"<td class='alt1'"+(ibd?" style='background:rgb(255,255,204);'":"")+">"+"<span class='smallfont' style='float:right'><span class='time'>"+ha(parseInt(ps[i].getElementsByTagName("hour")[0].firstChild.nodeValue))+":"+ps[i].getElementsByTagName("minute")[0].firstChild.nodeValue+" "+ps[i].getElementsByTagName("ampm")[0].firstChild.nodeValue+"</span></span><a style='text-decoration:none' href='javascript:widget.openURL(\"http://forums.macrumors.com/member.php?u="+ps[i].getElementsByTagName("userid")[0].firstChild.nodeValue+"\");'"+(nw==''?" target='_blank'":"")+">"+ps[i].getElementsByTagName("username")[0].firstChild.nodeValue.unescapeHTML()+"</a>"+"</td>"+"<td class='alt2'"+(ibd?" style='background:rgb(255,255,204);'":"")+">"+(isu?"<span style='float:right'><img class='inlineimg' src='http://media.macrumorslive.com/f/images/misc/subscribed.gif' alt='You are subscribed to this thread' title='You are subscribed to this thread' /></span>":"")+"<div>"+(rc==0?"<strong>":"")+"<a style='text-decoration:none' href='javascript:widget.openURL(\"http://forums.macrumors.com/showthread.php?t="+ps[i].getElementsByTagName("id")[0].firstChild.nodeValue+"\");'"+(nw==''?" target='_blank'":"")+"><img src='http://media.macrumorslive.com/f/images/buttons/sortdesc.gif' width='12' height='12' alt='Go to first post' title='Go to first post' border='0' class='inlineimg' /></a> <a style='text-decoration:none' href='javascript:widget.openURL(\"http://forums.macrumors.com/showthread.php?p="+ps[i].getElementsByTagName("postid")[0].firstChild.nodeValue+"#post"+ps[i].getElementsByTagName("postid")[0].firstChild.nodeValue+"\");'"+(nw==''?" target='_blank'":"")+">"+ps[i].getElementsByTagName("title")[0].firstChild.nodeValue.unescapeHTML()+"</a>"+(rc==0?"</strong>":"")+"</div>"+"</td>"+"<td class='alt1' align='center'"+(ibd?" style='background:rgb(255,255,204);'":"")+">"+nf(rc)+"</td>"+"<td class='alt2'"+(ibd?" style='background:rgb(255,255,204);'":"")+">"+"<a style='text-decoration:none' href='javascript:widget.openURL(\"http://forums.macrumors.com/forumdisplay.php?f="+ps[i].getElementsByTagName("forumid")[0].firstChild.nodeValue+"\");'"+(nw==''?" target='_blank'":"")+">"+ps[i].getElementsByTagName("forumname")[0].firstChild.nodeValue+"</a></td>"+"</td>"+"</tr>");nrw.push(inf)}}}}
function d(){if(nrw.length==0)return 0;rw.push(nrw.pop());g();if(nrw.length>0){setTimeout("d()",dl)}}
function h(){var nid=(Math.round(Math.random()*2000)+100);x();if(rN){rN.onreadystatechange=p2;rN.open("GET",bu+"?do=xml&lpi="+lpi+"&"+nid,true);rN.send(null)}}
function g(){var m="";for(i=rw.length-1;i>=Math.max(0,rw.length-60);i--){var ds=1;for(j=0;j<exc.length;j++){if(va==0&&exc[j]==rw[i][0]){ds=0}}if(ds==1){m=m+rw[i][1]}}$("postsdiv").innerHTML="<table class='tborder' cellpadding='6' cellspacing='1' border='0' width='100%' align='center'><tr>"+"<td class='thead' width='20%'><span style='float:right'>When</span>Who</td>"+"<td class='thead' align='center' nowrap='nowrap'>What</td>"+"<td class='thead' align='center' nowrap='nowrap'>Replies</td>"+"<td class='thead' width='25%'>Where</td>"+"</tr>"+m+"</table>";if(m==""){$("postsdiv").innerHTML=$("postsdiv").innerHTML+"<p align='center'>Loading posts, please wait...</p><hr/>"}}
function ex(){if(exc.length>1){$("exc_option").innerHTML=" | <form name='excludeform'><input type='radio' name='excludeoption' onClick='va=1;document.excludeform.excludeoption[1].checked=false;g();'"+(va==1?" checked":"")+" /> View all <input type='radio' name='excludeoption' onClick='va=0;document.excludeform.excludeoption[0].checked=false;g();'"+(va==0?" checked":"")+" /> Ignore your "+(exc.length-1)+" excluded  forum"+(exc.length-1!=1?"s":"")+"</form>"}else{$("exc_option").innerHTML=""}}
function sp(){var ag="";exc=new Array();exc.push('41');for(i=0;i<document.preferences_form.fx.length;i++){if(document.preferences_form.fx[i].checked==false){ag=ag+document.preferences_form.fx[i].value+",";exc.push(document.preferences_form.fx[i].value)}}if(document.preferences_form.nw.checked==false){nw=1}else{nw=''}var aj=new Ajax.Request("http://spy.macrumors.com/",{method:'get',parameters:"do=saveprefs&nw="+nw+"&fx="+ag,onComplete:sr})}
function os(){$('preferencestable').style.display='block';return true}
function oc(){if(nw==1){document.preferences_form.nw.checked=false}else{document.preferences_form.nw.checked=true}for(i=0;i<document.preferences_form.fx.length;i++){document.preferences_form.fx[i].checked=true;for(j=0;j<exc.length;j++){if(exc[j]==document.preferences_form.fx[i].value){document.preferences_form.fx[i].checked=false}}}$('preferencestable').style.display='none';return false}
function ov(){sp();$('preferencestable').style.display='none';ex();g();return false;}
function sr(){ex()}
function nf(nStr){nStr+='';k=nStr.split('.');k1=k[0];k2=k.length>1?'.'+k[1]:'';var rgx=/(\d+)(\d{3})/;while(rgx.test(k1)){k1=k1.replace(rgx,'$1'+','+'$2')}return k1+k2}
function ha(hr){hr=hr-hd;if(hr<0){hr=hr+12}else if(hr>12){hr=hr-12}return hr}